/* ***********************************************************
   *                                                         *
   * Copyright, (C) Honeywell Bull Inc., 1987                *
   *                                                         *
   * Copyright, (C) Honeywell Information Systems Inc., 1982 *
   *                                                         *
   *********************************************************** */

/* op_mnemonic_.cds -- successor to the illegible op_mnemonic.alm */

/* format: style2 */

op_mnemonic_:
     procedure;

/* BIM 12/82 */
/* Modified to not need the bce/Multics versions! March 1985 by Keith Loepere. */

declare create_data_segment_ entry (pointer, fixed binary (35));
declare com_err_ entry() options(variable);
declare code fixed bin (35);

%include cds_args;
%include op_mnemonic_dcl_;

          declare 1 CDSA                 aligned like cds_args;
	declare 1 OI		 aligned,
		2 op_mnemonic	 bit (0) aligned,	/* programs reference this ... */
		2 op_mnemonic_	 (0:1023) aligned like op_mnemonic;

	declare 1 unused		 aligned like op_mnemonic;


	unspec (unused) = ""b;
	unused.name = "....  ";
	unused.num_words = 1;
	OI.op_mnemonic_ (*) = unused;

	call set_opcode (2, "mme1  ", 0, 0, 1);
	call set_opcode (4, "drl   ", 0, 0, 1);
	call set_opcode (8, "mme2  ", 0, 0, 1);
	call set_opcode (10, "mme3  ", 0, 0, 1);
	call set_opcode (14, "mme4  ", 0, 0, 1);
	call set_opcode (18, "nop   ", 0, 0, 1);
	call set_opcode (20, "puls1 ", 0, 0, 1);
	call set_opcode (22, "puls2 ", 0, 0, 1);
	call set_opcode (26, "cioc  ", 0, 0, 1);
	call set_opcode (32, "adlx0 ", 0, 0, 1);
	call set_opcode (33, "mve   ", 0, 3, 4);
	call set_opcode (34, "adlx1 ", 0, 0, 1);
	call set_opcode (36, "adlx2 ", 0, 0, 1);
	call set_opcode (38, "adlx3 ", 0, 0, 1);
	call set_opcode (40, "adlx4 ", 0, 0, 1);
	call set_opcode (41, "mvne  ", 2, 3, 4);
	call set_opcode (42, "adlx5 ", 0, 0, 1);
	call set_opcode (44, "adlx6 ", 0, 0, 1);
	call set_opcode (46, "adlx7 ", 0, 0, 1);
	call set_opcode (52, "ldqc  ", 0, 0, 1);
	call set_opcode (54, "adl   ", 0, 0, 1);
	call set_opcode (56, "ldac  ", 0, 0, 1);
	call set_opcode (58, "adla  ", 0, 0, 1);
	call set_opcode (60, "adlq  ", 0, 0, 1);
	call set_opcode (62, "adlaq ", 0, 0, 1);
	call set_opcode (64, "asx0  ", 0, 0, 1);
	call set_opcode (66, "asx1  ", 0, 0, 1);
	call set_opcode (68, "asx2  ", 0, 0, 1);
	call set_opcode (70, "asx3  ", 0, 0, 1);
	call set_opcode (72, "asx4  ", 0, 0, 1);
	call set_opcode (74, "asx5  ", 0, 0, 1);
	call set_opcode (76, "asx6  ", 0, 0, 1);
	call set_opcode (78, "asx7  ", 0, 0, 1);
	call set_opcode (80, "adwp0 ", 0, 0, 1);
	call set_opcode (82, "adwp1 ", 0, 0, 1);
	call set_opcode (84, "adwp2 ", 0, 0, 1);
	call set_opcode (86, "adwp3 ", 0, 0, 1);
	call set_opcode (88, "aos   ", 0, 0, 1);
	call set_opcode (90, "asa   ", 0, 0, 1);
	call set_opcode (92, "asq   ", 0, 0, 1);
	call set_opcode (94, "sscr  ", 0, 0, 1);
	call set_opcode (96, "adx0  ", 0, 0, 1);
	call set_opcode (97, "csl   ", 1, 2, 3);
	call set_opcode (98, "adx1  ", 0, 0, 1);
	call set_opcode (99, "csr   ", 1, 2, 3);
	call set_opcode (100, "adx2  ", 0, 0, 1);
	call set_opcode (102, "adx3  ", 0, 0, 1);
	call set_opcode (104, "adx4  ", 0, 0, 1);
	call set_opcode (105, "sztl  ", 1, 2, 3);
	call set_opcode (106, "adx5  ", 0, 0, 1);
	call set_opcode (107, "sztr  ", 1, 2, 3);
	call set_opcode (108, "adx6  ", 0, 0, 1);
	call set_opcode (109, "cmpb  ", 1, 2, 3);
	call set_opcode (110, "adx7  ", 0, 0, 1);
	call set_opcode (114, "awca  ", 0, 0, 1);
	call set_opcode (116, "awcq  ", 0, 0, 1);
	call set_opcode (118, "lreg  ", 0, 0, 1);
	call set_opcode (122, "ada   ", 0, 0, 1);
	call set_opcode (124, "adq   ", 0, 0, 1);
	call set_opcode (126, "adaq  ", 0, 0, 1);
	call set_opcode (128, "cmpx0 ", 0, 0, 1);
	call set_opcode (129, "mlr   ", 0, 2, 3);
	call set_opcode (130, "cmpx1 ", 0, 0, 1);
	call set_opcode (131, "mrl   ", 0, 2, 3);
	call set_opcode (132, "cmpx2 ", 0, 0, 1);
	call set_opcode (134, "cmpx3 ", 0, 0, 1);
	call set_opcode (136, "cmpx4 ", 0, 0, 1);
	call set_opcode (138, "cmpx5 ", 0, 0, 1);
	call set_opcode (140, "cmpx6 ", 0, 0, 1);
	call set_opcode (141, "cmpc  ", 0, 2, 3);
	call set_opcode (142, "cmpx7 ", 0, 0, 1);
	call set_opcode (146, "cwl   ", 0, 0, 1);
	call set_opcode (154, "cmpa  ", 0, 0, 1);
	call set_opcode (156, "cmpq  ", 0, 0, 1);
	call set_opcode (158, "cmpaq ", 0, 0, 1);
	call set_opcode (160, "sblx0 ", 0, 0, 1);
	call set_opcode (161, "scd   ", 0, 2, 4);
	call set_opcode (162, "sblx1 ", 0, 0, 1);
	call set_opcode (163, "scdr  ", 0, 2, 4);
	call set_opcode (164, "sblx2 ", 0, 0, 1);
	call set_opcode (166, "sblx3 ", 0, 0, 1);
	call set_opcode (168, "sblx4 ", 0, 0, 1);
	call set_opcode (169, "scm   ", 0, 2, 4);
	call set_opcode (170, "sblx5 ", 0, 0, 1);
	call set_opcode (171, "scmr  ", 0, 2, 4);
	call set_opcode (172, "sblx6 ", 0, 0, 1);
	call set_opcode (174, "sblx7 ", 0, 0, 1);
	call set_opcode (186, "sbla  ", 0, 0, 1);
	call set_opcode (188, "sblq  ", 0, 0, 1);
	call set_opcode (190, "sblaq ", 0, 0, 1);
	call set_opcode (192, "ssx0  ", 0, 0, 1);
	call set_opcode (194, "ssx1  ", 0, 0, 1);
	call set_opcode (196, "ssx2  ", 0, 0, 1);
	call set_opcode (198, "ssx3  ", 0, 0, 1);
	call set_opcode (200, "ssx4  ", 0, 0, 1);
	call set_opcode (202, "ssx5  ", 0, 0, 1);
	call set_opcode (204, "ssx6  ", 0, 0, 1);
	call set_opcode (206, "ssx7  ", 0, 0, 1);
	call set_opcode (208, "adwp4 ", 0, 0, 1);
	call set_opcode (210, "adwp5 ", 0, 0, 1);
	call set_opcode (212, "adwp6 ", 0, 0, 1);
	call set_opcode (214, "adwp7 ", 0, 0, 1);
	call set_opcode (216, "sdbr  ", 0, 0, 1);
	call set_opcode (217, "sptr  ", 0, 0, 1);
	call set_opcode (218, "ssa   ", 0, 0, 1);
	call set_opcode (220, "ssq   ", 0, 0, 1);
	call set_opcode (224, "sbx0  ", 0, 0, 1);
	call set_opcode (225, "mvt   ", 0, 2, 4);
	call set_opcode (226, "sbx1  ", 0, 0, 1);
	call set_opcode (228, "sbx2  ", 0, 0, 1);
	call set_opcode (230, "sbx3  ", 0, 0, 1);
	call set_opcode (232, "sbx4  ", 0, 0, 1);
	call set_opcode (233, "tct   ", 0, 1, 4);
	call set_opcode (234, "sbx5  ", 0, 0, 1);
	call set_opcode (235, "tctr  ", 0, 1, 4);
	call set_opcode (236, "sbx6  ", 0, 0, 1);
	call set_opcode (238, "sbx7  ", 0, 0, 1);
	call set_opcode (242, "swca  ", 0, 0, 1);
	call set_opcode (244, "swcq  ", 0, 0, 1);
	call set_opcode (246, "lpri  ", 0, 0, 1);
	call set_opcode (247, "lptr  ", 0, 0, 1);
	call set_opcode (250, "sba   ", 0, 0, 1);
	call set_opcode (252, "sbq   ", 0, 0, 1);
	call set_opcode (254, "sbaq  ", 0, 0, 1);
	call set_opcode (256, "cnax0 ", 0, 0, 1);
	call set_opcode (258, "cnax1 ", 0, 0, 1);
	call set_opcode (260, "cnax2 ", 0, 0, 1);
	call set_opcode (261, "ad2d  ", 2, 2, 3);
	call set_opcode (262, "cnax3 ", 0, 0, 1);
	call set_opcode (263, "sb2d  ", 2, 2, 3);
	call set_opcode (264, "cnax4 ", 0, 0, 1);
	call set_opcode (266, "cnax5 ", 0, 0, 1);
	call set_opcode (268, "cnax6 ", 0, 0, 1);
	call set_opcode (269, "mp2d  ", 2, 2, 3);
	call set_opcode (270, "cnax7 ", 0, 0, 1);
	call set_opcode (271, "dv2d  ", 2, 2, 3);
	call set_opcode (274, "cmk   ", 0, 0, 1);
	call set_opcode (276, "absa  ", 0, 0, 1);
	call set_opcode (278, "epaq  ", 0, 0, 1);
	call set_opcode (280, "sznc  ", 0, 0, 1);
	call set_opcode (282, "cnaa  ", 0, 0, 1);
	call set_opcode (284, "cnaq  ", 0, 0, 1);
	call set_opcode (286, "cnaaq ", 0, 0, 1);
	call set_opcode (288, "ldx0  ", 0, 0, 1);
	call set_opcode (290, "ldx1  ", 0, 0, 1);
	call set_opcode (292, "ldx2  ", 0, 0, 1);
	call set_opcode (293, "ad3d  ", 2, 3, 4);
	call set_opcode (294, "ldx3  ", 0, 0, 1);
	call set_opcode (295, "sb3d  ", 2, 3, 4);
	call set_opcode (296, "ldx4  ", 0, 0, 1);
	call set_opcode (298, "ldx5  ", 0, 0, 1);
	call set_opcode (300, "ldx6  ", 0, 0, 1);
	call set_opcode (301, "mp3d  ", 2, 3, 4);
	call set_opcode (302, "ldx7  ", 0, 0, 1);
	call set_opcode (303, "dv3d  ", 2, 3, 4);
	call set_opcode (304, "lbar  ", 0, 0, 1);
	call set_opcode (306, "rsw   ", 0, 0, 1);
	call set_opcode (308, "ldbr  ", 0, 0, 1);
	call set_opcode (309, "lsdr  ", 0, 0, 1);
	call set_opcode (310, "rmcm  ", 0, 0, 1);
	call set_opcode (312, "szn   ", 0, 0, 1);
	call set_opcode (314, "lda   ", 0, 0, 1);
	call set_opcode (316, "ldq   ", 0, 0, 1);
	call set_opcode (318, "ldaq  ", 0, 0, 1);
	call set_opcode (320, "orsx0 ", 0, 0, 1);
	call set_opcode (322, "orsx1 ", 0, 0, 1);
	call set_opcode (324, "orsx2 ", 0, 0, 1);
	call set_opcode (326, "orsx3 ", 0, 0, 1);
	call set_opcode (328, "orsx4 ", 0, 0, 1);
	call set_opcode (330, "orsx5 ", 0, 0, 1);
	call set_opcode (332, "orsx6 ", 0, 0, 1);
	call set_opcode (334, "orsx7 ", 0, 0, 1);
	call set_opcode (336, "spri0 ", 0, 0, 1);
	call set_opcode (337, "spbp0 ", 0, 0, 1);
	call set_opcode (338, "spbp1 ", 0, 0, 1);
	call set_opcode (339, "spri1 ", 0, 0, 1);
	call set_opcode (340, "spri2 ", 0, 0, 1);
	call set_opcode (341, "spbp2 ", 0, 0, 1);
	call set_opcode (342, "spbp3 ", 0, 0, 1);
	call set_opcode (343, "spri3 ", 0, 0, 1);
	call set_opcode (344, "spri  ", 0, 0, 1);
	call set_opcode (345, "ssdr  ", 0, 0, 1);
	call set_opcode (346, "orsa  ", 0, 0, 1);
	call set_opcode (348, "orsq  ", 0, 0, 1);
	call set_opcode (350, "lsdp  ", 0, 0, 1);
	call set_opcode (351, "lptp  ", 0, 0, 1);
	call set_opcode (352, "orx0  ", 0, 0, 1);
	call set_opcode (354, "orx1  ", 0, 0, 1);
	call set_opcode (356, "orx2  ", 0, 0, 1);
	call set_opcode (358, "orx3  ", 0, 0, 1);
	call set_opcode (360, "orx4  ", 0, 0, 1);
	call set_opcode (362, "orx5  ", 0, 0, 1);
	call set_opcode (364, "orx6  ", 0, 0, 1);
	call set_opcode (366, "orx7  ", 0, 0, 1);
	call set_opcode (368, "tsp0  ", 0, 0, 1);
	call set_opcode (370, "tsp1  ", 0, 0, 1);
	call set_opcode (372, "tsp2  ", 0, 0, 1);
	call set_opcode (374, "tsp3  ", 0, 0, 1);
	call set_opcode (378, "ora   ", 0, 0, 1);
	call set_opcode (380, "orq   ", 0, 0, 1);
	call set_opcode (382, "oraq  ", 0, 0, 1);
	call set_opcode (384, "canx0 ", 0, 0, 1);
	call set_opcode (385, "mvn   ", 2, 2, 3);
	call set_opcode (386, "canx1 ", 0, 0, 1);
	call set_opcode (387, "btd   ", 2, 2, 3);
	call set_opcode (388, "canx2 ", 0, 0, 1);
	call set_opcode (390, "canx3 ", 0, 0, 1);
	call set_opcode (391, "cmpn  ", 2, 2, 3);
	call set_opcode (392, "canx4 ", 0, 0, 1);
	call set_opcode (394, "canx5 ", 0, 0, 1);
	call set_opcode (395, "dtb   ", 2, 2, 3);
	call set_opcode (396, "canx6 ", 0, 0, 1);
	call set_opcode (398, "canx7 ", 0, 0, 1);
	call set_opcode (400, "eawp0 ", 0, 0, 1);
	call set_opcode (401, "easp1 ", 0, 0, 1);
	call set_opcode (402, "easp0 ", 0, 0, 1);
	call set_opcode (403, "eawp1 ", 0, 0, 1);
	call set_opcode (404, "eawp2 ", 0, 0, 1);
	call set_opcode (405, "easp3 ", 0, 0, 1);
	call set_opcode (406, "easp2 ", 0, 0, 1);
	call set_opcode (407, "eawp3 ", 0, 0, 1);
	call set_opcode (410, "cana  ", 0, 0, 1);
	call set_opcode (412, "canq  ", 0, 0, 1);
	call set_opcode (414, "canaq ", 0, 0, 1);
	call set_opcode (416, "lcx0  ", 0, 0, 1);
	call set_opcode (418, "lcx1  ", 0, 0, 1);
	call set_opcode (420, "lcx2  ", 0, 0, 1);
	call set_opcode (422, "lcx3  ", 0, 0, 1);
	call set_opcode (424, "lcx4  ", 0, 0, 1);
	call set_opcode (426, "lcx5  ", 0, 0, 1);
	call set_opcode (428, "lcx6  ", 0, 0, 1);
	call set_opcode (430, "lcx7  ", 0, 0, 1);
	call set_opcode (432, "eawp4 ", 0, 0, 1);
	call set_opcode (433, "easp5 ", 0, 0, 1);
	call set_opcode (434, "easp4 ", 0, 0, 1);
	call set_opcode (435, "eawp5 ", 0, 0, 1);
	call set_opcode (436, "eawp6 ", 0, 0, 1);
	call set_opcode (437, "easp7 ", 0, 0, 1);
	call set_opcode (438, "easp6 ", 0, 0, 1);
	call set_opcode (439, "eawp7 ", 0, 0, 1);
	call set_opcode (442, "lca   ", 0, 0, 1);
	call set_opcode (444, "lcq   ", 0, 0, 1);
	call set_opcode (446, "lcaq  ", 0, 0, 1);
	call set_opcode (448, "ansx0 ", 0, 0, 1);
	call set_opcode (450, "ansx1 ", 0, 0, 1);
	call set_opcode (452, "ansx2 ", 0, 0, 1);
	call set_opcode (454, "ansx3 ", 0, 0, 1);
	call set_opcode (456, "ansx4 ", 0, 0, 1);
	call set_opcode (458, "ansx5 ", 0, 0, 1);
	call set_opcode (460, "ansx6 ", 0, 0, 1);
	call set_opcode (462, "ansx7 ", 0, 0, 1);
	call set_opcode (464, "epp0  ", 0, 0, 1);
	call set_opcode (465, "epbp0 ", 0, 0, 1);
	call set_opcode (466, "epbp1 ", 0, 0, 1);
	call set_opcode (467, "epp1  ", 0, 0, 1);
	call set_opcode (468, "epp2  ", 0, 0, 1);
	call set_opcode (469, "epbp2 ", 0, 0, 1);
	call set_opcode (470, "epbp3 ", 0, 0, 1);
	call set_opcode (471, "epp3  ", 0, 0, 1);
	call set_opcode (472, "stac  ", 0, 0, 1);
	call set_opcode (474, "ansa  ", 0, 0, 1);
	call set_opcode (476, "ansq  ", 0, 0, 1);
	call set_opcode (478, "stcd  ", 0, 0, 1);
	call set_opcode (480, "anx0  ", 0, 0, 1);
	call set_opcode (482, "anx1  ", 0, 0, 1);
	call set_opcode (484, "anx2  ", 0, 0, 1);
	call set_opcode (486, "anx3  ", 0, 0, 1);
	call set_opcode (488, "anx4  ", 0, 0, 1);
	call set_opcode (490, "anx5  ", 0, 0, 1);
	call set_opcode (492, "anx6  ", 0, 0, 1);
	call set_opcode (494, "anx7  ", 0, 0, 1);
	call set_opcode (496, "epp4  ", 0, 0, 1);
	call set_opcode (497, "epbp4 ", 0, 0, 1);
	call set_opcode (498, "epbp5 ", 0, 0, 1);
	call set_opcode (499, "epp5  ", 0, 0, 1);
	call set_opcode (500, "epp6  ", 0, 0, 1);
	call set_opcode (501, "epbp6 ", 0, 0, 1);
	call set_opcode (502, "epbp7 ", 0, 0, 1);
	call set_opcode (503, "epp7  ", 0, 0, 1);
	call set_opcode (506, "ana   ", 0, 0, 1);
	call set_opcode (508, "anq   ", 0, 0, 1);
	call set_opcode (510, "anaq  ", 0, 0, 1);
	call set_opcode (514, "mpf   ", 0, 0, 1);
	call set_opcode (516, "mpy   ", 0, 0, 1);
	call set_opcode (522, "cmg   ", 0, 0, 1);
	call set_opcode (530, "lde   ", 0, 0, 1);
	call set_opcode (534, "rscr  ", 0, 0, 1);
	call set_opcode (538, "ade   ", 0, 0, 1);
	call set_opcode (546, "ufm   ", 0, 0, 1);
	call set_opcode (550, "dufm  ", 0, 0, 1);
	call set_opcode (554, "fcmg  ", 0, 0, 1);
	call set_opcode (558, "dfcmg ", 0, 0, 1);
	call set_opcode (560, "fszn  ", 0, 0, 1);
	call set_opcode (562, "fld   ", 0, 0, 1);
	call set_opcode (566, "dfld  ", 0, 0, 1);
	call set_opcode (570, "ufa   ", 0, 0, 1);
	call set_opcode (574, "dufa  ", 0, 0, 1);
	call set_opcode (576, "sxl0  ", 0, 0, 1);
	call set_opcode (578, "sxl1  ", 0, 0, 1);
	call set_opcode (580, "sxl2  ", 0, 0, 1);
	call set_opcode (582, "sxl3  ", 0, 0, 1);
	call set_opcode (583, "sareg ", 0, 0, 1);
	call set_opcode (584, "sxl4  ", 0, 0, 1);
	call set_opcode (586, "sxl5  ", 0, 0, 1);
	call set_opcode (588, "sxl6  ", 0, 0, 1);
	call set_opcode (590, "sxl7  ", 0, 0, 1);
	call set_opcode (591, "spl   ", 0, 0, 1);
	call set_opcode (592, "stz   ", 0, 0, 1);
	call set_opcode (594, "smic  ", 0, 0, 1);
	call set_opcode (596, "scpr  ", 0, 0, 1);
	call set_opcode (600, "stt   ", 0, 0, 1);
	call set_opcode (602, "fst   ", 0, 0, 1);
	call set_opcode (604, "ste   ", 0, 0, 1);
	call set_opcode (606, "dfst  ", 0, 0, 1);
	call set_opcode (610, "fmp   ", 0, 0, 1);
	call set_opcode (614, "dfmp  ", 0, 0, 1);
	call set_opcode (615, "lareg ", 0, 0, 1);
	call set_opcode (623, "lpl   ", 0, 0, 1);
	call set_opcode (624, "fstr  ", 0, 0, 1);
	call set_opcode (626, "frd   ", 0, 0, 1);
	call set_opcode (628, "dfstr ", 0, 0, 1);
	call set_opcode (630, "dfrd  ", 0, 0, 1);
	call set_opcode (634, "fad   ", 0, 0, 1);
	call set_opcode (638, "dfad  ", 0, 0, 1);
	call set_opcode (640, "rpl   ", 0, 1, 1);
	call set_opcode (641, "a9bd  ", 1, 0, 1);
	call set_opcode (643, "a6bd  ", 1, 0, 1);
	call set_opcode (645, "a4bd  ", 1, 0, 1);
	call set_opcode (647, "abd   ", 1, 0, 1);
	call set_opcode (650, "bcd   ", 0, 0, 1);
	call set_opcode (652, "div   ", 0, 0, 1);
	call set_opcode (654, "dvf   ", 0, 0, 1);
	call set_opcode (655, "awd   ", 1, 0, 1);
	call set_opcode (662, "fneg  ", 0, 0, 1);
	call set_opcode (666, "fcmp  ", 0, 0, 1);
	call set_opcode (670, "dfcmp ", 0, 0, 1);
	call set_opcode (672, "rpt   ", 0, 1, 1);
	call set_opcode (673, "s9bd  ", 1, 0, 1);
	call set_opcode (675, "s6bd  ", 1, 0, 1);
	call set_opcode (677, "s4bd  ", 1, 0, 1);
	call set_opcode (679, "sbd   ", 1, 0, 1);
	call set_opcode (682, "fdi   ", 0, 0, 1);
	call set_opcode (686, "dfdi  ", 0, 0, 1);
	call set_opcode (687, "swd   ", 1, 0, 1);
	call set_opcode (690, "neg   ", 0, 0, 1);
	call set_opcode (692, "cams  ", 0, 0, 1);
	call set_opcode (693, "camp  ", 0, 0, 1);
	call set_opcode (694, "negl  ", 0, 0, 1);
	call set_opcode (698, "ufs   ", 0, 0, 1);
	call set_opcode (702, "dufs  ", 0, 0, 1);
	call set_opcode (704, "sprp0 ", 0, 0, 1);
	call set_opcode (705, "ara0  ", 0, 0, 1);
	call set_opcode (706, "sprp1 ", 0, 0, 1);
	call set_opcode (707, "ara1  ", 0, 0, 1);
	call set_opcode (708, "sprp2 ", 0, 0, 1);
	call set_opcode (709, "ara2  ", 0, 0, 1);
	call set_opcode (710, "sprp3 ", 0, 0, 1);
	call set_opcode (711, "ara3  ", 0, 0, 1);
	call set_opcode (712, "sprp4 ", 0, 0, 1);
	call set_opcode (713, "ara4  ", 0, 0, 1);
	call set_opcode (714, "sprp5 ", 0, 0, 1);
	call set_opcode (715, "ara5  ", 0, 0, 1);
	call set_opcode (716, "sprp6 ", 0, 0, 1);
	call set_opcode (717, "ara6  ", 0, 0, 1);
	call set_opcode (718, "sprp7 ", 0, 0, 1);
	call set_opcode (719, "ara7  ", 0, 0, 1);
	call set_opcode (720, "sbar  ", 0, 0, 1);
	call set_opcode (722, "stba  ", 0, 1, 1);
	call set_opcode (724, "stbq  ", 0, 1, 1);
	call set_opcode (726, "smcm  ", 0, 0, 1);
	call set_opcode (728, "stc1  ", 0, 0, 1);
	call set_opcode (734, "ssdp  ", 0, 0, 1);
	call set_opcode (735, "sptp  ", 0, 0, 1);
	call set_opcode (736, "rpd   ", 0, 1, 1);
	call set_opcode (737, "aar0  ", 0, 0, 1);
	call set_opcode (739, "aar1  ", 0, 0, 1);
	call set_opcode (741, "aar2  ", 0, 0, 1);
	call set_opcode (743, "aar3  ", 0, 0, 1);
	call set_opcode (745, "aar4  ", 0, 0, 1);
	call set_opcode (746, "fdv   ", 0, 0, 1);
	call set_opcode (747, "aar5  ", 0, 0, 1);
	call set_opcode (749, "aar6  ", 0, 0, 1);
	call set_opcode (750, "dfdv  ", 0, 0, 1);
	call set_opcode (751, "aar7  ", 0, 0, 1);
	call set_opcode (758, "fno   ", 0, 0, 1);
	call set_opcode (762, "fsb   ", 0, 0, 1);
	call set_opcode (766, "dfsb  ", 0, 0, 1);
	call set_opcode (768, "tze   ", 0, 0, 1);
	call set_opcode (769, "trtn  ", 0, 0, 1);
	call set_opcode (770, "tnz   ", 0, 0, 1);
	call set_opcode (771, "trtf  ", 0, 0, 1);
	call set_opcode (772, "tnc   ", 0, 0, 1);
	call set_opcode (774, "trc   ", 0, 0, 1);
	call set_opcode (776, "tmi   ", 0, 0, 1);
	call set_opcode (777, "tmoz  ", 0, 0, 1);
	call set_opcode (778, "tpl   ", 0, 0, 1);
	call set_opcode (779, "tpnz  ", 0, 0, 1);
	call set_opcode (781, "ttn   ", 0, 0, 1);
	call set_opcode (782, "ttf   ", 0, 0, 1);
	call set_opcode (784, "rtcd  ", 0, 0, 1);
	call set_opcode (790, "rcu   ", 0, 0, 1);
	call set_opcode (792, "teo   ", 0, 0, 1);
	call set_opcode (794, "teu   ", 0, 0, 1);
	call set_opcode (796, "dis   ", 0, 0, 1);
	call set_opcode (798, "tov   ", 0, 0, 1);
	call set_opcode (800, "eax0  ", 0, 0, 1);
	call set_opcode (802, "eax1  ", 0, 0, 1);
	call set_opcode (804, "eax2  ", 0, 0, 1);
	call set_opcode (806, "eax3  ", 0, 0, 1);
	call set_opcode (808, "eax4  ", 0, 0, 1);
	call set_opcode (810, "eax5  ", 0, 0, 1);
	call set_opcode (812, "eax6  ", 0, 0, 1);
	call set_opcode (814, "eax7  ", 0, 0, 1);
	call set_opcode (816, "ret   ", 0, 0, 1);
	call set_opcode (822, "rccl  ", 0, 0, 1);
	call set_opcode (824, "ldi   ", 0, 0, 1);
	call set_opcode (826, "eaa   ", 0, 0, 1);
	call set_opcode (828, "eaq   ", 0, 0, 1);
	call set_opcode (830, "ldt   ", 0, 0, 1);
	call set_opcode (832, "ersx0 ", 0, 0, 1);
	call set_opcode (833, "arn0  ", 0, 0, 1);
	call set_opcode (834, "ersx1 ", 0, 0, 1);
	call set_opcode (835, "arn1  ", 0, 0, 1);
	call set_opcode (836, "ersx2 ", 0, 0, 1);
	call set_opcode (837, "arn2  ", 0, 0, 1);
	call set_opcode (838, "ersx3 ", 0, 0, 1);
	call set_opcode (839, "arn3  ", 0, 0, 1);
	call set_opcode (840, "ersx4 ", 0, 0, 1);
	call set_opcode (841, "arn4  ", 0, 0, 1);
	call set_opcode (842, "ersx5 ", 0, 0, 1);
	call set_opcode (843, "arn5  ", 0, 0, 1);
	call set_opcode (844, "ersx6 ", 0, 0, 1);
	call set_opcode (845, "arn6  ", 0, 0, 1);
	call set_opcode (846, "ersx7 ", 0, 0, 1);
	call set_opcode (847, "arn7  ", 0, 0, 1);
	call set_opcode (848, "spri4 ", 0, 0, 1);
	call set_opcode (849, "spbp4 ", 0, 0, 1);
	call set_opcode (850, "spbp5 ", 0, 0, 1);
	call set_opcode (851, "spri5 ", 0, 0, 1);
	call set_opcode (852, "spri6 ", 0, 0, 1);
	call set_opcode (853, "spbp6 ", 0, 0, 1);
	call set_opcode (854, "spbp7 ", 0, 0, 1);
	call set_opcode (855, "spri7 ", 0, 0, 1);
	call set_opcode (856, "stacq ", 0, 0, 1);
	call set_opcode (858, "ersa  ", 0, 0, 1);
	call set_opcode (860, "ersq  ", 0, 0, 1);
	call set_opcode (862, "scu   ", 0, 0, 1);
	call set_opcode (864, "erx0  ", 0, 0, 1);
	call set_opcode (865, "nar0  ", 0, 0, 1);
	call set_opcode (866, "erx1  ", 0, 0, 1);
	call set_opcode (867, "nar1  ", 0, 0, 1);
	call set_opcode (868, "erx2  ", 0, 0, 1);
	call set_opcode (869, "nar2  ", 0, 0, 1);
	call set_opcode (870, "erx3  ", 0, 0, 1);
	call set_opcode (871, "nar3  ", 0, 0, 1);
	call set_opcode (872, "erx4  ", 0, 0, 1);
	call set_opcode (873, "nar4  ", 0, 0, 1);
	call set_opcode (874, "erx5  ", 0, 0, 1);
	call set_opcode (875, "nar5  ", 0, 0, 1);
	call set_opcode (876, "erx6  ", 0, 0, 1);
	call set_opcode (877, "nar6  ", 0, 0, 1);
	call set_opcode (878, "erx7  ", 0, 0, 1);
	call set_opcode (879, "nar7  ", 0, 0, 1);
	call set_opcode (880, "tsp4  ", 0, 0, 1);
	call set_opcode (882, "tsp5  ", 0, 0, 1);
	call set_opcode (884, "tsp6  ", 0, 0, 1);
	call set_opcode (886, "tsp7  ", 0, 0, 1);
	call set_opcode (888, "lcpr  ", 0, 0, 1);
	call set_opcode (890, "era   ", 0, 0, 1);
	call set_opcode (892, "erq   ", 0, 0, 1);
	call set_opcode (894, "eraq  ", 0, 0, 1);
	call set_opcode (896, "tsx0  ", 0, 0, 1);
	call set_opcode (898, "tsx1  ", 0, 0, 1);
	call set_opcode (900, "tsx2  ", 0, 0, 1);
	call set_opcode (902, "tsx3  ", 0, 0, 1);
	call set_opcode (904, "tsx4  ", 0, 0, 1);
	call set_opcode (906, "tsx5  ", 0, 0, 1);
	call set_opcode (908, "tsx6  ", 0, 0, 1);
	call set_opcode (910, "tsx7  ", 0, 0, 1);
	call set_opcode (912, "tra   ", 0, 0, 1);
	call set_opcode (918, "call6 ", 0, 0, 1);
	call set_opcode (922, "tss   ", 0, 0, 1);
	call set_opcode (924, "xec   ", 0, 0, 1);
	call set_opcode (926, "xed   ", 0, 0, 1);
	call set_opcode (928, "lxl0  ", 0, 0, 1);
	call set_opcode (930, "lxl1  ", 0, 0, 1);
	call set_opcode (932, "lxl2  ", 0, 0, 1);
	call set_opcode (934, "lxl3  ", 0, 0, 1);
	call set_opcode (936, "lxl4  ", 0, 0, 1);
	call set_opcode (938, "lxl5  ", 0, 0, 1);
	call set_opcode (940, "lxl6  ", 0, 0, 1);
	call set_opcode (942, "lxl7  ", 0, 0, 1);
	call set_opcode (946, "ars   ", 0, 0, 1);
	call set_opcode (948, "qrs   ", 0, 0, 1);
	call set_opcode (950, "lrs   ", 0, 0, 1);
	call set_opcode (954, "als   ", 0, 0, 1);
	call set_opcode (956, "qls   ", 0, 0, 1);
	call set_opcode (958, "lls   ", 0, 0, 1);
	call set_opcode (960, "stx0  ", 0, 0, 1);
	call set_opcode (961, "sar0  ", 0, 0, 1);
	call set_opcode (962, "stx1  ", 0, 0, 1);
	call set_opcode (963, "sar1  ", 0, 0, 1);
	call set_opcode (964, "stx2  ", 0, 0, 1);
	call set_opcode (965, "sar2  ", 0, 0, 1);
	call set_opcode (966, "stx3  ", 0, 0, 1);
	call set_opcode (967, "sar3  ", 0, 0, 1);
	call set_opcode (968, "stx4  ", 0, 0, 1);
	call set_opcode (969, "sar4  ", 0, 0, 1);
	call set_opcode (970, "stx5  ", 0, 0, 1);
	call set_opcode (971, "sar5  ", 0, 0, 1);
	call set_opcode (972, "stx6  ", 0, 0, 1);
	call set_opcode (973, "sar6  ", 0, 0, 1);
	call set_opcode (974, "stx7  ", 0, 0, 1);
	call set_opcode (975, "sar7  ", 0, 0, 1);
	call set_opcode (976, "stc2  ", 0, 0, 1);
	call set_opcode (978, "stca  ", 0, 1, 1);
	call set_opcode (980, "stcq  ", 0, 1, 1);
	call set_opcode (982, "sreg  ", 0, 0, 1);
	call set_opcode (984, "sti   ", 0, 0, 1);
	call set_opcode (985, "sra   ", 0, 0, 1);
	call set_opcode (986, "sta   ", 0, 0, 1);
	call set_opcode (988, "stq   ", 0, 0, 1);
	call set_opcode (990, "staq  ", 0, 0, 1);
	call set_opcode (992, "lprp0 ", 0, 0, 1);
	call set_opcode (993, "lar0  ", 0, 0, 1);
	call set_opcode (994, "lprp1 ", 0, 0, 1);
	call set_opcode (995, "lar1  ", 0, 0, 1);
	call set_opcode (996, "lprp2 ", 0, 0, 1);
	call set_opcode (997, "lar2  ", 0, 0, 1);
	call set_opcode (998, "lprp3 ", 0, 0, 1);
	call set_opcode (999, "lar3  ", 0, 0, 1);
	call set_opcode (1000, "lprp4 ", 0, 0, 1);
	call set_opcode (1001, "lar4  ", 0, 0, 1);
	call set_opcode (1002, "lprp5 ", 0, 0, 1);
	call set_opcode (1003, "lar5  ", 0, 0, 1);
	call set_opcode (1004, "lprp6 ", 0, 0, 1);
	call set_opcode (1005, "lar6  ", 0, 0, 1);
	call set_opcode (1006, "lprp7 ", 0, 0, 1);
	call set_opcode (1007, "lar7  ", 0, 0, 1);
	call set_opcode (1010, "arl   ", 0, 0, 1);
	call set_opcode (1012, "qrl   ", 0, 0, 1);
	call set_opcode (1014, "lrl   ", 0, 0, 1);
	call set_opcode (1016, "gtb   ", 0, 0, 1);
	call set_opcode (1017, "lra   ", 0, 0, 1);
	call set_opcode (1018, "alr   ", 0, 0, 1);
	call set_opcode (1020, "qlr   ", 0, 0, 1);
	call set_opcode (1022, "llr   ", 0, 0, 1);

	CDSA.sections (1).p = addr (OI);
	CDSA.sections (1).len = size (OI);
	CDSA.sections (1).struct_name = "OI";
	CDSA.seg_name = "op_mnemonic_";
	CDSA.num_exclude_names = 0;
	CDSA.exclude_array_ptr = null ();
	string (CDSA.switches) = ""b;
	CDSA.switches.have_text = "1"b;

	call create_data_segment_ (addr (CDSA), code);
	if code ^= 0
	then call com_err_ (code, "op_mnemonic_");
	return;

set_opcode:
     procedure (Opx, Name, Dtype, Num_descs, Num_words);
	declare Opx		 fixed bin;
	declare Name		 char (6);
	declare Dtype		 fixed bin (2);
	declare Num_descs		 fixed bin (5);
	declare Num_words		 fixed bin (8);

	op_mnemonic_ptr = addr (OI.op_mnemonic_ (Opx));
	op_mnemonic.name = Name;
	op_mnemonic.dtype = Dtype;
	op_mnemonic.num_desc = Num_descs;
	op_mnemonic.num_words = Num_words;
     end set_opcode;
     end;
